/*

*/

import java.applet.Applet;
import java.awt.*;
import java.awt.geom.*;

/**
    This applet draws straight lines with antialiasing
    turned both on and off.
*/
@SuppressWarnings("serial")
public class AntialiasingDemo_JavaAPI extends Applet
{
   private static final int SIZE = 512;
   private static final int NUMBER_OF_LINES = 30;

   private static final Color backGroundColor  = Color.green;
   private static final Color foreGroundColor1 = Color.red;
   private static final Color foreGroundColor2 = Color.red;

   public void paint (Graphics g)
   {
      // recover Graphics2D
      Graphics2D g2 = (Graphics2D)g;

      g2.setColor(backGroundColor);
      g2.fillRect(0, 0, 2*SIZE + 1, SIZE + 1);
      g2.setColor(foreGroundColor1);

      // draw the left half of the screen using anti-aliased lines
      g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
      for (int i = 0; i <= NUMBER_OF_LINES; i++)
      {
         g.drawLine(0, SIZE, SIZE, SIZE - (int)(i * ((double)SIZE/(double)NUMBER_OF_LINES)) );
         g.drawLine(0, SIZE, (int)(i * ((double)SIZE/(double)NUMBER_OF_LINES)), 0 );
      }

      // draw the right half of the screen using default lines
      g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF);
      for (int i = 0; i <= NUMBER_OF_LINES; i++)
      {
         g.drawLine(SIZE, SIZE, 2*SIZE, SIZE - (int)(i * ((double)SIZE/(double)NUMBER_OF_LINES)) );
         g.drawLine(SIZE, SIZE, SIZE + (int)(i * ((double)SIZE/(double)NUMBER_OF_LINES)), 0 );
      }
   }//paint
}